
//+------------------------------------------------------------------+
//|                                       Louw Coetzer aka FX Sniper |
//|                      Copyright  2004, MetaQuotes Software Corp. |
//|                                       http://www.metaquotes.net/ |
//| FX_Sniper's_Ergodic_CCI_Trigger_Alert_Mod.mq4
//+------------------------------------------------------------------+
#property  copyright "Copyright  2004, Fx Sniper."
#property  link      "http://www.dunno.net/"

//+------------------------------------------------------------------+
//| FX_Sniper's_Ergodic_CCI_&_Trigger_Alert_Fast      by      mladen |
//+------------------------------------------------------------------+
//2008fxtsd

#property copyright "mladen"
#property link      "mladenfx@gmail.com"

#property indicator_separate_window
#property indicator_buffers    5
#property indicator_color1     DeepSkyBlue
#property indicator_width1     2
#property indicator_color2     OrangeRed
#property indicator_style2     STYLE_DOT
#property indicator_color3     White
#property indicator_style3     STYLE_DASH
#property indicator_color4     Crimson
#property indicator_width4     1
#property indicator_color5     LimeGreen
#property indicator_width5     1
#property indicator_levelcolor MediumOrchid

//
//
//
//
//

#define mtm    0
#define absmtm 1
#define var1   2
#define var2   3
#define var2a  4
#define var2b  5
#define var2c  6
#define var2d  7

//
//
//
//
//

extern string  TimeFrame         = "Current time frame";
extern int     pq                = 2;
extern int     pr                = 10;
extern int     ps                = 5;
extern int     trigger           = 1;
extern int     SmoothLength      = 5;
extern double  SmoothPhase       = 0;
extern bool    SmoothDouble      = true;
extern int     HighLowPeriod     = 30;
extern bool    ShowChannel       = true;
extern bool    ShowZigZag        = true;
extern bool    Interpolate       = true;
extern int     levelOs           = -200;
extern int     levelOb           = 200;    

extern string  _                 = "alerts settings";
extern bool    alertsOn          = true;
extern bool    alertsOnCurrent   = true;
extern bool    alertsMessage     = true;
extern bool    alertsSound       = false;
extern bool    alertsEmail       = false;

extern string  __                = "arrows settings";
extern bool   arrowsVisible      = true;
extern double arrowsDisplacement = 1.0;
extern string arrowsIdentifier   = "ergodic cci arrows";
extern color  arrowsUpColor      = Lime;
extern color  arrowsDnColor      = Orange;

//
//
//
//
//

double ergocci[];
double maincci[];
double zz[];
double hb[];
double lb[];
double zzlow[];
double zzhigh[];
double trend[];
double buffer[][8];

string indicatorFileName;
bool   returnBars;
bool   calculateValue;
int    timeFrame;

//
//
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

int init()
{
    IndicatorBuffers(8);
    SetIndexBuffer(0,ergocci); SetIndexLabel(0,"Ergodic CCI");
    SetIndexBuffer(1,maincci); SetIndexLabel(1,"Trigger Line");
    SetIndexBuffer(2,zz);      SetIndexLabel(2,NULL);          SetIndexStyle(2,DRAW_SECTION);       
    SetIndexBuffer(3,hb);
    SetIndexBuffer(4,lb);
    SetIndexBuffer(5,zzlow);
    SetIndexBuffer(6,zzhigh);
    SetIndexBuffer(7,trend);
    
    SetLevelValue(0,levelOs);
    SetLevelValue(1,levelOb);
    SetLevelValue(2,0);
   
     SetIndexEmptyValue(0,0);
     SetIndexEmptyValue(1,0);
     SetIndexEmptyValue(2,0);
     SetIndexEmptyValue(5,0);
     SetIndexEmptyValue(6,0);
   
     if (ShowChannel)
     {
     SetIndexStyle(3,DRAW_LINE);
     SetIndexStyle(4,DRAW_LINE);
     }
     else      
     {
     SetIndexStyle(3,DRAW_NONE);
     SetIndexStyle(4,DRAW_NONE);
     }
   
     //
     //
     //
     //
     //
   
       indicatorFileName = WindowExpertName();
       calculateValue    = (TimeFrame=="calculateValue"); if (calculateValue) return(0);
       returnBars        = (TimeFrame=="returnBars");     if (returnBars)     return(0);
       timeFrame         = stringToTimeFrame(TimeFrame);
   
   IndicatorShortName(timeFrameToString(timeFrame) +  " Ergodic Cci channel"); 
   
return(0); 
} 

//
//
//
//
//

int deinit() 
{ 
   if (!calculateValue && arrowsVisible) deleteArrows();  
return(0); 
} 

//
//
//
//
//

int start() 
{  
   int counted_bars=IndicatorCounted();
   int lastZag;
   int i,r,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1); 
         if (returnBars) { ergocci[0] = MathMin(limit+1,Bars-1); return(0); }
         
   //
   //
   //
   //
   //
   
   if (calculateValue || timeFrame == Period())
   {     
      
      if (ShowZigZag)
      for (lastZag=limit+1; lastZag<Bars; lastZag++) if (zzlow[lastZag] != 0 || zzhigh[lastZag] != 0) break;
      
      if (ArrayRange(buffer,0) != Bars) ArrayResize(buffer,Bars); 
      for(i=limit,r=Bars-limit-1; i >=0; i--,r++) 
      {
      
         double alphaPq      = 2.0/(1.0+pq);
         double alphaPr      = 2.0/(1.0+pr);
         double alphaPs      = 2.0/(1.0+ps);
         double alphaTrigger = 2.0/(1.0+trigger);
         
         buffer[r][mtm]    = Close[i] - Close[i+1];
         buffer[r][absmtm] = MathAbs(buffer[r][mtm]);
         buffer[r][var1]   = buffer[r-1][var1]  + alphaPq * (buffer[r][mtm]   - buffer[r-1][var1]);
         buffer[r][var2]   = buffer[r-1][var2]  + alphaPr * (buffer[r][var1]  - buffer[r-1][var2]);
         buffer[r][var2a]  = buffer[r-1][var2a] + alphaPq * (buffer[r][absmtm]- buffer[r-1][var2a]);
         buffer[r][var2b]  = buffer[r-1][var2b] + alphaPr * (buffer[r][var2a] - buffer[r-1][var2b]);
         buffer[r][var2c]  = buffer[r-1][var2c] + alphaPs * (buffer[r][var2]  - buffer[r-1][var2c]);
         buffer[r][var2d]  = buffer[r-1][var2d] + alphaPs * (buffer[r][var2b] - buffer[r-1][var2d]);
      
         if (buffer[r][var2d]!=0)
               ergocci[i] = iDSmooth((500*buffer[r][var2c]/buffer[r][var2d]),                  SmoothLength,SmoothPhase,SmoothDouble,i, 0);    
         else  ergocci[i] = iDSmooth(0,                                                        SmoothLength,SmoothPhase,SmoothDouble,i, 0);    
               maincci[i] = iDSmooth(maincci[i+1] + alphaTrigger * (ergocci[i] - maincci[i+1]),SmoothLength,SmoothPhase,SmoothDouble,i, 20);    
        
               lb[i] = ergocci[ArrayMinimum(ergocci,HighLowPeriod,i)];
               hb[i] = ergocci[ArrayMaximum(ergocci,HighLowPeriod,i)];
          
               //
               //
               //
               //
               //
   
               trend[i] = trend[i+1];
               if(ergocci[i] < hb[i] && ergocci[i+1] >= hb[i+1]) trend[i] =-1; 
               if(ergocci[i] > lb[i] && ergocci[i+1] <= lb[i+1]) trend[i] = 1;
               manageArrow(i); 
              
   //
   //
   //
   //
   //
   
   if (!ShowZigZag) continue;
      
              zzlow[i]  = 0;
              zzhigh[i] = 0;
              
              if (lb[i] < lb[i+1])
              {
                  if (zz[lastZag] == lb[lastZag])
                      zz[lastZag] =  0;
                      zz[i]       =  lb[i];
                      zzlow[i]    =  lb[i];
                          lastZag =  i;
                          continue;
              }
              
              if (hb[i] > hb[i+1])
              {
                  if (zz[lastZag] == hb[lastZag])
                      zz[lastZag] =  0;
                      zz[i]       =  hb[i];
                      zzhigh[i]   =  hb[i];
                          lastZag =  i;
                          continue;
              }
              
              if (zz[i] != 0)
              {
                  zz[i] = 0;
                  for (lastZag=i+1; lastZag<Bars; lastZag++)
                  {
                     if (zzlow[lastZag]  != 0) { zz[lastZag] = zzlow[lastZag];  break; }
                     if (zzhigh[lastZag] != 0) { zz[lastZag] = zzhigh[lastZag]; break; }
                  }
                  
              }
    
          }
            
        manageAlerts();   
    return(0); 
    }
    
    //
    //
    //
    //
    //
    
    limit = MathMax(limit,MathMin(Bars,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
    if (ShowZigZag) for (lastZag=limit+1; lastZag<Bars; lastZag++) if (zzlow[lastZag] != 0 || zzhigh[lastZag] != 0) break;
    for (i=limit;i>=0; i--)
    {
        int y = iBarShift(NULL,timeFrame,Time[i]);
            ergocci[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",pq,pr,ps,trigger,SmoothLength,SmoothPhase,SmoothDouble,HighLowPeriod,ShowChannel,ShowZigZag,0,y);
            maincci[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",pq,pr,ps,trigger,SmoothLength,SmoothPhase,SmoothDouble,HighLowPeriod,ShowChannel,ShowZigZag,1,y);
            zz[i]      = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",pq,pr,ps,trigger,SmoothLength,SmoothPhase,SmoothDouble,HighLowPeriod,ShowChannel,ShowZigZag,2,y);
            hb[i]      = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",pq,pr,ps,trigger,SmoothLength,SmoothPhase,SmoothDouble,HighLowPeriod,ShowChannel,ShowZigZag,3,y);
            lb[i]      = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",pq,pr,ps,trigger,SmoothLength,SmoothPhase,SmoothDouble,HighLowPeriod,ShowChannel,ShowZigZag,4,y);
            zzlow[i]   = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",pq,pr,ps,trigger,SmoothLength,SmoothPhase,SmoothDouble,HighLowPeriod,ShowChannel,ShowZigZag,5,y);
            zzhigh[i]  = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",pq,pr,ps,trigger,SmoothLength,SmoothPhase,SmoothDouble,HighLowPeriod,ShowChannel,ShowZigZag,6,y);
            trend[i]   = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",pq,pr,ps,trigger,SmoothLength,SmoothPhase,SmoothDouble,HighLowPeriod,ShowChannel,ShowZigZag,7,y);

            manageArrow(i);
            
            //
            //
            //
            //
            //
      
            if (!Interpolate || y==iBarShift(NULL,timeFrame,Time[i-1])) continue;

            //
            //
            //
            //
            //

            datetime time = iTime(NULL,timeFrame,y);
               for(int n = 1; i+n < Bars && Time[i+n] >= time; n++) continue;	
               for(int k = 1; k < n; k++)
               {
                  ergocci[i+k] = ergocci[i] + (ergocci[i+n] - ergocci[i]) * k/n;
                  maincci[i+k] = maincci[i] + (maincci[i+n] - maincci[i]) * k/n;
                  hb[i+k]      = hb[i]      + (hb[i+n]      - hb[i])      * k/n;
                  lb[i+k]      = lb[i]      + (lb[i+n]      - lb[i])      * k/n;
               
              }  	            
   }
      
   manageAlerts();
      
   return(0);
}
            
//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
//
//
//
//
//

double wrk[][40];

#define bsmax  5
#define bsmin  6
#define volty  7
#define vsum   8
#define avolty 9

//
//
//
//
//

double iDSmooth(double price, double length, double phase, bool isDouble, int i, int s=0)
{
   if (isDouble)
         return (iSmooth(iSmooth(price,MathSqrt(length),phase,i,s),MathSqrt(length),phase,i,s+10));
   else  return (iSmooth(price,length,phase,i,s));
}

//
//
//
//
//

double iSmooth(double price, double length, double phase, int i, int s=0)
{
   if (length <=1) return(price);
   if (ArrayRange(wrk,0) != Bars) ArrayResize(wrk,Bars);
   
   int r = Bars-i-1; 
      if (r==0) { for(int k=0; k<7; k++) wrk[r][k+s]=price; for(; k<10; k++) wrk[r][k+s]=0; return(price); }

   //
   //
   //
   //
   //
   
      double len1   = MathMax(MathLog(MathSqrt(0.5*(length-1)))/MathLog(2.0)+2.0,0);
      double pow1   = MathMax(len1-2.0,0.5);
      double del1   = price - wrk[r-1][bsmax+s];
      double del2   = price - wrk[r-1][bsmin+s];
      double div    = 1.0/(10.0+10.0*(MathMin(MathMax(length-10,0),100))/100);
      int    forBar = MathMin(r,10);
	
         wrk[r][volty+s] = 0;
               if(MathAbs(del1) > MathAbs(del2)) wrk[r][volty+s] = MathAbs(del1); 
               if(MathAbs(del1) < MathAbs(del2)) wrk[r][volty+s] = MathAbs(del2); 
         wrk[r][vsum+s] =	wrk[r-1][vsum+s] + (wrk[r][volty+s]-wrk[r-forBar][volty+s])*div;
         
         //
         //
         //
         //
         //
   
         wrk[r][avolty+s] = wrk[r-1][avolty+s]+(2.0/(MathMax(4.0*length,30)+1.0))*(wrk[r][vsum+s]-wrk[r-1][avolty+s]);
            if (wrk[r][avolty+s] > 0)
               double dVolty = wrk[r][volty+s]/wrk[r][avolty+s]; else dVolty = 0;   
	               if (dVolty > MathPow(len1,1.0/pow1)) dVolty = MathPow(len1,1.0/pow1);
                  if (dVolty < 1)                      dVolty = 1.0;

      //
      //
      //
      //
      //
	        
   	double pow2 = MathPow(dVolty, pow1);
      double len2 = MathSqrt(0.5*(length-1))*len1;
      double Kv   = MathPow(len2/(len2+1), MathSqrt(pow2));

         if (del1 > 0) wrk[r][bsmax+s] = price; else wrk[r][bsmax+s] = price - Kv*del1;
         if (del2 < 0) wrk[r][bsmin+s] = price; else wrk[r][bsmin+s] = price - Kv*del2;
	
   //
   //
   //
   //
   //
      
      double R     = MathMax(MathMin(phase,100),-100)/100.0 + 1.5;
      double beta  = 0.45*(length-1)/(0.45*(length-1)+2);
      double alpha = MathPow(beta,pow2);

         wrk[r][0+s] = price + alpha*(wrk[r-1][0+s]-price);
         wrk[r][1+s] = (price - wrk[r][0+s])*(1-beta) + beta*wrk[r-1][1+s];
         wrk[r][2+s] = (wrk[r][0+s] + R*wrk[r][1+s]);
         wrk[r][3+s] = (wrk[r][2+s] - wrk[r-1][4+s])*MathPow((1-alpha),2) + MathPow(alpha,2)*wrk[r-1][3+s];
         wrk[r][4+s] = (wrk[r-1][4+s] + wrk[r][3+s]); 

   //
   //
   //
   //
   //

   return(wrk[r][4+s]);
}

//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = StringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}

//
//
//
//
//

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string StringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int tchar = StringGetChar(s, length);
         if((tchar > 96 && tchar < 123) || (tchar > 223 && tchar < 256))
                     s = StringSetChar(s, length, tchar - 32);
         else if(tchar > -33 && tchar < 0)
                     s = StringSetChar(s, length, tchar + 224);
   }
   return(s);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

void manageArrow(int i)
{
   if (!calculateValue && arrowsVisible)
   {
         deleteArrow(Time[i]);
         if (trend[i]!=trend[i+1])
         {
            if (trend[i] == 1) drawArrow(i,arrowsUpColor,221,false);
            if (trend[i] ==-1) drawArrow(i,arrowsDnColor,222,true);
         }
   }
}               

//
//
//
//
//

void drawArrow(int i,color theColor,int theCode,bool up)
{
   string name = arrowsIdentifier+":"+Time[i];
   double gap  = iATR(NULL,0,20,i);
   
      //
      //
      //
      //
      //
      
      ObjectCreate(name,OBJ_ARROW,0,Time[i],0);
         ObjectSet(name,OBJPROP_ARROWCODE,theCode);
         ObjectSet(name,OBJPROP_COLOR,theColor);
         if (up)
               ObjectSet(name,OBJPROP_PRICE1,High[i]+arrowsDisplacement*gap);
         else  ObjectSet(name,OBJPROP_PRICE1,Low[i] -arrowsDisplacement*gap);
}

//
//
//
//
//

void deleteArrows()
{
   string lookFor       = arrowsIdentifier+":";
   int    lookForLength = StringLen(lookFor);
   for (int i=ObjectsTotal()-1; i>=0; i--)
   {
      string objectName = ObjectName(i);
         if (StringSubstr(objectName,0,lookForLength) == lookFor) ObjectDelete(objectName);
   }
}

//
//
//
//
//

void deleteArrow(datetime time)
{
   string lookFor = arrowsIdentifier+":"+time; ObjectDelete(lookFor);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

void manageAlerts()
{
   if (!calculateValue && alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1; whichBar = iBarShift(NULL,0,iTime(NULL,timeFrame,whichBar));
      if (trend[whichBar] != trend[whichBar+1])
      {
         if (trend[whichBar] == 1) doAlert(whichBar,"up");
         if (trend[whichBar] ==-1) doAlert(whichBar,"down");
      }         
   }
}   

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[forBar]) {
          previousAlert  = doWhat;
          previousTime   = Time[forBar];

          //
          //
          //
          //
          //

          message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," Ergodic Cci trend changed to ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol()," Ergodic Cci "),message);
             if (alertsSound)   PlaySound("alert2.wav");
      }
}
       
         
       
      
   